
/*****************************************************************************
**
** program_ugnx4_create_FPDF_version_05.cpp

  FPDF ()
 8  2007 
 1  2007  

1.	 UG   (  TeamCenter),
	 ,   

2.	    ,
	 ,   

3.	  <  FPDF>,   
	 :
	< FPDF> - <  >
	<  FPDF> - <aaa>
	< > - < 10   >
	< > - <A>
	<> - <   >
	   ,  
	      <ENTER>,
	  
	      <Apply>
	  <OK>      

4.	  <  ()>
	  -   PATH <tested>
	     

5.	   FPDF   Head Line
	
6.	   $$PATH   Position and Action line


**
** Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/



/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif





#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_modl.h>
#include <uf_defs.h>
#include <uf_mtx.h>
#include <uf_ugmgr.h>
#include <uf_attr.h>




#include <uf_defs.h>
#include <uf_exit.h>

#include <uf_styler.h>
#include <uf_mb.h> 
#include "fpdf_name.h"




#define CHANGE_CB_COUNT ( 8 + 1 ) /* Add 1 for the terminator */



static UF_STYLER_callback_info_t CHANGE_cbs[CHANGE_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, CHANGE_constructor_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, CHANGE_ok_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB        , 0, CHANGE_apply_cb},
 {CHANGE_FPDF_NAME      , UF_STYLER_ACTIVATE_CB     , 0, CHANGE_fpdf_name_cb},
 {CHANGE_ADD_FPDF_NAME  , UF_STYLER_ACTIVATE_CB     , 0, CHANGE_add_fpdf_name_cb},
 {CHANGE_ASSEMBLY_NAME  , UF_STYLER_ACTIVATE_CB     , 0, CHANGE_assembly_name_cb},
 {CHANGE_AREA_NAME      , UF_STYLER_ACTIVATE_CB     , 0, CHANGE_area_name_cb},
 {CHANGE_DATE           , UF_STYLER_ACTIVATE_CB     , 0, CHANGE_date_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



static UF_MB_styler_actions_t actions[] = {
    { "fpdf_name.dlg",  NULL,   CHANGE_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};


static	FILE*	prterr;
static	FILE*	fpdf;
static	int		errorCode;
static	tag_t	disp_tag;	
static	char	FPDF_name[100];
static	char	add_FPDF_name[100];
static	char	assembly_name[100];
static	char	area_name[100];
static	char	date[100];
static	char	file_dlg[100]="\\\\hp00\\server\\user_tools\\win\\application\\fpdf_name.dlg";

//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}






//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
		fflush(prterr);
		
	}
}









int CHANGE_constructor_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{

	UF_STYLER_item_value_type_t	value;
	
	//  " FPDF".....................
	//......................................................
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_FPDF_NAME;
	value.value.string=assembly_name;


	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	strcpy(FPDF_name,assembly_name);



	//  "  FPDF".......
	//.......................................................
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_ADD_FPDF_NAME;
	value.value.string="aaa";
	

	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	strcpy(add_FPDF_name,"aaa");


	//  " ".......
	//.......................................................
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_ASSEMBLY_NAME;
	value.value.string=assembly_name;


	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;



	//  " ".......
	//.......................................................
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_AREA_NAME;
	value.value.string="A";


	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	strcpy(area_name,"A");


	//  "".......
	char	tmp_buf[128];
	char	year[10];
	char	year2[10]="20";
	char	ch='/';
	char	day[10];
	char	month[10];
	char*	pdest;

	_tzset();//set time zone
	_strdate(tmp_buf);//copies the current local data into the buffer
	
	pdest=strrchr(tmp_buf,ch);

	if(pdest != NULL)
	{
		strcpy(year,pdest+1);
		strcat(year2,year);
	
	}


	*pdest='\0';
	pdest=strrchr(tmp_buf,ch);

	if(pdest != NULL)
	{
		strcpy(day,pdest+1);
	
	}

	

	*pdest='\0';
	strcpy(month,tmp_buf);
	
	char	Date_Of_Programming[20];

	strcpy(Date_Of_Programming,day);
	strcat(Date_Of_Programming,"-");
	strcat(Date_Of_Programming,month);
	strcat(Date_Of_Programming,"-");
	strcat(Date_Of_Programming,year2);

	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_DATE;
	value.value.string=Date_Of_Programming;

	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	strcpy(date,Date_Of_Programming);





    return (UF_UI_CB_CONTINUE_DIALOG); 
 
term:
	return UF_UI_CB_EXIT_DIALOG;

}




int CHANGE_ok_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t	value;

	//  <FPDF_name>
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_FPDF_NAME;

	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(FPDF_name,value.value.string);

	errorCode=UF_STYLER_free_value (&value);PRTERR;



	//  <add_FPDF_name>
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_ADD_FPDF_NAME;

	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(add_FPDF_name,value.value.string);
		
	errorCode=UF_STYLER_free_value (&value);PRTERR;
   

	//  <assambly_name>
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_ASSEMBLY_NAME;

	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(assembly_name,value.value.string);
		
	errorCode=UF_STYLER_free_value (&value);PRTERR;
   


	//  <area_name>
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_AREA_NAME;

	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(assembly_name,value.value.string);
		
	errorCode=UF_STYLER_free_value (&value);PRTERR;




	//  <date>
	value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_DATE;

	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(assembly_name,value.value.string);
		
	errorCode=UF_STYLER_free_value (&value);PRTERR;






term:
	return (UF_UI_CB_EXIT_DIALOG); 
}











int CHANGE_apply_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	UF_STYLER_item_value_type_t	value;


	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_FPDF_NAME;
	value.value.integer=TRUE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_ADD_FPDF_NAME;
	value.value.integer=TRUE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_ASSEMBLY_NAME;
	value.value.integer=TRUE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_AREA_NAME;
	value.value.integer=TRUE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_DATE;
	value.value.integer=TRUE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;

    /* Callback acknowledged, do not terminate dialog                 */
    /* A return value of UF_UI_CB_EXIT_DIALOG will not be accepted    */
    /* for this callback type.  You must respond to your apply button.*/
    return (UF_UI_CB_CONTINUE_DIALOG); 
term:
	return ( UF_UI_CB_EXIT_DIALOG );               

}








int CHANGE_fpdf_name_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{

	UF_STYLER_item_value_type_t	value;
   
    value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_FPDF_NAME;
	
	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(FPDF_name,value.value.string);
	
	fprintf(prterr,"\n\tFPDF_name = \t%s\n\n",FPDF_name);

	errorCode=UF_STYLER_free_value (&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_FPDF_NAME;
	value.value.integer=FALSE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	
	


    return (UF_UI_CB_CONTINUE_DIALOG); 
    
term:
	return ( UF_UI_CB_EXIT_DIALOG );               
}





int CHANGE_add_fpdf_name_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	
	UF_STYLER_item_value_type_t	value;
   
    value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_ADD_FPDF_NAME;
	
	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(add_FPDF_name,value.value.string);
	
	fprintf(prterr,"\n\tadd_FPDF_name = \t%s\n\n",add_FPDF_name);

	errorCode=UF_STYLER_free_value (&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_ADD_FPDF_NAME;
	value.value.integer=FALSE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	
	


    return (UF_UI_CB_CONTINUE_DIALOG); 
    
term:
	return ( UF_UI_CB_EXIT_DIALOG );               
}







int CHANGE_assembly_name_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	UF_STYLER_item_value_type_t	value;
   
    value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_ASSEMBLY_NAME;
	
	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(assembly_name,value.value.string);
	
	fprintf(prterr,"\n\tassembly_name = \t%s\n\n",assembly_name);

	errorCode=UF_STYLER_free_value (&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_ASSEMBLY_NAME;
	value.value.integer=FALSE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	
	


    return (UF_UI_CB_CONTINUE_DIALOG); 
    
term:
	return ( UF_UI_CB_EXIT_DIALOG );           
}








int CHANGE_area_name_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
	UF_STYLER_item_value_type_t	value;
   
    value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_AREA_NAME;
	
	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(area_name,value.value.string);
	
	fprintf(prterr,"\n\tarea_name = \t%s\n\n",area_name);

	errorCode=UF_STYLER_free_value (&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_AREA_NAME;
	value.value.integer=FALSE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	
	


    return (UF_UI_CB_CONTINUE_DIALOG); 
    
term:
	return ( UF_UI_CB_EXIT_DIALOG );           
}









int CHANGE_date_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{

UF_STYLER_item_value_type_t	value;
   
    value.item_attr=UF_STYLER_VALUE;
	value.item_id=CHANGE_DATE;
	
	errorCode=UF_STYLER_ask_value(dialog_id,&value);PRTERR;

	strcpy(date,value.value.string);
	
	fprintf(prterr,"\n\tdate = \t%s\n\n",date);

	errorCode=UF_STYLER_free_value (&value);PRTERR;

	value.item_attr=UF_STYLER_SENSITIVITY;
	value.item_id=CHANGE_DATE;
	value.value.integer=FALSE;
	errorCode=UF_STYLER_set_value(dialog_id,&value);PRTERR;
	
	


    return (UF_UI_CB_CONTINUE_DIALOG); 
    
term:
	return ( UF_UI_CB_EXIT_DIALOG );           

}







//11  2007   15-30
static int	is_path_proc
(tag_t object,int type[3],void* user_data,UF_UI_selection_p_t	select)

{
	static	int		title_type;
	static	UF_ATTR_value_t	value;
	
	errorCode=UF_ATTR_find_attribute
	(object,UF_ATTR_string,"PATH",&title_type);PRTERR;

	if(title_type==UF_ATTR_string)
	{
		errorCode=UF_ATTR_read_value(object,"PATH",UF_ATTR_any,&value);PRTERR;
		if(strcmp(value.value.string,"tested")==0)
			return UF_UI_SEL_ACCEPT;
	}

term:
	return UF_UI_SEL_REJECT;
}








static int path_init_proc(UF_UI_selection_p_t select, void* user_data)
{

	int				ret_code;
	int				sel_code;
	int				num_triples=1;
	
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};



	ret_code=UF_UI_set_sel_mask
	(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	sel_code=UF_UI_set_sel_procs(select,is_path_proc,NULL,user_data);

	if((ret_code==0) && (sel_code==0))
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;

}







//*********************************************************
//
//   Position and Action Line
//
//*********************************************************
int	Position_and_Action_Line
(char*	path_name, tag_t	member_array[],	int	member_count)
{

	UF_ATTR_value_t	value;
	int				i;
	char*	attr_title="point_id";
	int		attr_type=UF_ATTR_string;
	int		title_type;

	static	struct	SORTED_MEMBERS
	{
		tag_t	member;
		char	point_id[15];
	}	rivet[100];


	char	pr_code[10];
	char	ad_code[10];
	char	fast_code[20];
	char	 grip_lng[20];


	//  <<point_id>>
	for(i=0;i<member_count;i++)
	{
		errorCode=UF_ATTR_find_attribute
		(member_array[i],attr_type,attr_title,&title_type);PRTERR;
		if(title_type==UF_ATTR_string)
		{
			errorCode=UF_ATTR_read_value
			(member_array[i],"point_id",UF_ATTR_any,&value);PRTERR;


			/*fprintf(prterr,"\n\t%s\n",value.value.string);*/
			
			rivet[i].member=member_array[i];
			strcpy(rivet[i].point_id,value.value.string);

			UF_free(value.value.string);

		}
		else
		{
			uc1601("   point_id",1);
			fprintf(prterr,"\n\t   point_id   %s\tline=%d\n",
			path_name,__LINE__);
			goto term;
		}
	}
	


	{

		int		i,j;
		tag_t	member_tmp;
		char	point_id_tmp[15];
		int		cmp_result;

		//   
		for(i=0;i<member_count-1;i++)
			for(j=i+1;j<member_count;j++)
				{
					cmp_result=strcmp(rivet[i].point_id,rivet[j].point_id);
					if(cmp_result>0)
					{
						member_tmp=rivet[i].member;
						strcpy(point_id_tmp,rivet[i].point_id);
						
						rivet[i].member=rivet[j].member;
						strcpy(rivet[i].point_id,rivet[j].point_id);

						rivet[j].member=member_tmp;
						strcpy(rivet[j].point_id,point_id_tmp);
					}

				}




	}


	//  Position and Line
	{

		int		i;
		
		char	part_name[257];
		char	refset_name[31];
		char	instance_name[129];
		double	origin[3];
		double	csys_matrix[9];
		double	transform[4][4];

		int		title_type;


		double	wcs_zero[3];
		double	abs_zero[3]={0,0,0};
		double	wcs_normal[3];
		double	wcs_origin[3];




		for(i=0;i<member_count;i++)
		{
			//  
			errorCode=UF_ASSEM_ask_component_data
			(rivet[i].member,part_name,refset_name,instance_name,
			origin,csys_matrix,transform);PRTERR;

			//**********************************************************
			//**********************************************************

			//    <pr_code> ( )
			errorCode=UF_ATTR_find_attribute(rivet[i].member,
			UF_ATTR_string,"pr_code",&title_type);
			
			if(title_type!=UF_ATTR_string)
			{
				uc1601("   <pr_code>",1);
				fprintf(prterr,"\n\t   <pr_code> "
				" %s  %s \tline=%d\n",
				rivet[i].point_id,path_name,__LINE__);
				goto term;
			}

			errorCode=UF_ATTR_read_value
			(rivet[i].member,"pr_code",UF_ATTR_any,&value);PRTERR;
			strcpy(pr_code,value.value.string);
			UF_free(value.value.string);
			//fprintf(prterr,"\n\tpr_code= %s\n",pr_code);


			//**********************************************************
			//**********************************************************


			//    <ad_code> ( )
			errorCode=UF_ATTR_find_attribute(rivet[i].member,
			UF_ATTR_string,"ad_code",&title_type);
			
			if(title_type!=UF_ATTR_string)
			{
				uc1601("   <ad_code>",1);
				fprintf(prterr,"\n\t   <ad_code> "
				" %s  %s \tline=%d\n",
				rivet[i].point_id,path_name,__LINE__);
				goto term;
			}

			errorCode=UF_ATTR_read_value
			(rivet[i].member,"ad_code",UF_ATTR_any,&value);PRTERR;
			strcpy(ad_code,value.value.string);
			UF_free(value.value.string);
			//fprintf(prterr,"\n\tad_code= %s\n",ad_code);


			//**********************************************************
			//**********************************************************



			//    <fast_code> ( )
			errorCode=UF_ATTR_find_attribute(rivet[i].member,
			UF_ATTR_string,"fast_code",&title_type);
			
			if(title_type!=UF_ATTR_string)
			{
				uc1601("   <fast_code>",1);
				fprintf(prterr,"\n\t   <fast_code> "
				" %s  %s \tline=%d\n",
				rivet[i].point_id,path_name,__LINE__);
				goto term;
			}

			errorCode=UF_ATTR_read_value
			(rivet[i].member,"fast_code",UF_ATTR_any,&value);PRTERR;
			strcpy(fast_code,value.value.string);
			UF_free(value.value.string);
			//fprintf(prterr,"\n\tfast_code= %s\n",ad_code);


			//**********************************************************
			//**********************************************************






			//    <grip_lng> ( )
			errorCode=UF_ATTR_find_attribute(rivet[i].member,
			UF_ATTR_string,"grip_lng",&title_type);
			
			if(title_type!=UF_ATTR_string)
			{
				uc1601("   <grip_lng>",1);
				fprintf(prterr,"\n\t   <grip_lng> "
				" %s  %s \tline=%d\n",
				rivet[i].point_id,path_name,__LINE__);
				goto term;
			}

			errorCode=UF_ATTR_read_value
			(rivet[i].member,"grip_lng",UF_ATTR_any,&value);PRTERR;
			strcpy(grip_lng,value.value.string);
			UF_free(value.value.string);
			//fprintf(prterr,"\n\tgrip_lng= %s\n",ad_code);


			//**********************************************************
			//**********************************************************


		
			// <origin>  <csys_matrix[6-8]>
			// <ABS of the displayed part>  <WCS of the displayed part

			errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,origin,
			UF_CSYS_ROOT_WCS_COORDS,wcs_origin);PRTERR;

			errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,&csys_matrix[6],
			UF_CSYS_ROOT_WCS_COORDS,wcs_normal);PRTERR;

			errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,abs_zero,
			UF_CSYS_ROOT_WCS_COORDS,wcs_zero);PRTERR;

			UF_VEC3_sub(wcs_origin,wcs_zero,origin);
			UF_VEC3_sub(wcs_normal,wcs_zero,&csys_matrix[6]);

			fprintf(fpdf,"%1.1s,\t",pr_code);
			fprintf(fpdf,"%1.1s,\t",ad_code);
			fprintf(fpdf,"%12.12s,\t",fast_code);
			fprintf(fpdf,"%3.3s,\t",grip_lng);
			fprintf(fpdf,"%12.12s,\t",rivet[i].point_id);
			fprintf(fpdf,"0,\t");
			fprintf(fpdf,"%15.5f,\t",wcs_origin[0]);
			fprintf(fpdf,"%15.5f,\t",wcs_origin[1]);
			fprintf(fpdf,"%15.5f,\t",wcs_origin[2]);
			fprintf(fpdf,"%15.5f,\t",csys_matrix[6]);
			fprintf(fpdf,"%15.5f,\t",csys_matrix[7]);
			fprintf(fpdf,"%15.5f,\t",csys_matrix[8]);
			fprintf(fpdf,"1, 0, 0\n");

		}

	}










	goto term;

term:
	return errorCode;

}






// 
int	do_it(void)
{



	//*********************************************************************
	// (0)-  UG  ,     
	//*********************************************************************
	{
		logical	is_active;
	
		errorCode=UF_is_ugmanager_active(&is_active);
		if(is_active)
		{
			fprintf(prterr,"\n\t NX\\Manager is active\n");
		}
		else
		{
			uc1601("UG NX4  ?",1);
			fprintf(prterr,"\n\t NX\\Manager is not active\n");
		}
	}




	//*********************************************
	// (1)-    
	//*********************************************
	{
		char	disp_name[300];
		

		char	part_number[UF_UGMGR_PARTNO_SIZE+1];
		char	part_revision[UF_UGMGR_PARTREV_SIZE+1];
		char	part_file_type[UF_UGMGR_FTYPE_SIZE+1];
		char	part_file_name[UF_UGMGR_FNAME_SIZE+1];


		//   
		disp_tag=UF_PART_ask_display_part();
		if(disp_tag==NULL_TAG)
		{
			uc1601("  ?",1);
			fprintf(prterr,"\n\t  ?\tline=%d\n",__LINE__);
			goto term;
		}

		//   
		errorCode=UF_PART_ask_part_name(disp_tag,disp_name);PRTERR;
	
	

		//Decodes the specified NX Manager part file name into its constituent elements - 
		//the part number, part revision, part file type, and part file name.
		errorCode=UF_UGMGR_decode_part_filename
		(disp_name,part_number,part_revision,part_file_type,part_file_name);PRTERR;
	
		strcpy(assembly_name,part_number);


		int	response;

label_create_dialog:
		errorCode=UF_STYLER_create_dialog ( file_dlg,
           CHANGE_cbs,      /* Callbacks from dialog */
           CHANGE_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           &response );PRTERR;

		switch(response)
		{
			case UF_UI_OK: break;
			case UF_UI_CANCEL: errorCode=0;goto term;
			case UF_UI_BACK: goto label_create_dialog;
			case UF_UI_PICK_RESPONSE: uc1601("UF_UI_PICK_RESPONSE",1); goto term;
			case UF_UI_CB_TERMINATE: uc1601("UF_UI_CB_TERMINATE",1); goto term;
		}

				

	}





	//********************************************************
	// (2) -  FPDF    Head_Line
	//********************************************************
	{
		
		char	template_fpdf[100];

        
		strcat(FPDF_name,add_FPDF_name);
		
		sprintf(template_fpdf,"D:\\%s.fpdf",FPDF_name);

		if((fpdf=fopen(template_fpdf,"w"))!=NULL)
			goto label_head_line;

		uc1601("     <*.fpdf>",1);
		fprintf(prterr,"\n\t     <*.fpdf>\tline=%d\n",
		__LINE__);
		goto term;


label_head_line:

		fprintf(fpdf,"$$HEAD,\t%s,\t%s,\tIPAC,\t%s\n",assembly_name,area_name,date);


	}


	tag_p_t	path_array;
	int		path_count;

label_select_path:
	//******************************************************
	// (3) -   - 
	//******************************************************
	{

		char*	message="  ()";
		char*	title="  ()";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		int		count;
		tag_p_t	object;
		int		i;


		errorCode=UF_UI_select_with_class_dialog
		(message,title,scope,path_init_proc,NULL,&response,&count,&object);PRTERR;
		
		switch(response)
		{

		case UF_UI_BACK: goto label_create_dialog;
		case UF_UI_CANCEL: goto term;
		case UF_UI_OK: break;

		}


		if(count==0)
		{
			uc1601("  , ?",1);
			goto	label_select_path;
		}

		path_array=object;
		path_count=count;

		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);PRTERR;
		}

	}







	//******************************************************
	// (4) -  Path Info Line,   
	//******************************************************
	{
		int	i;
					
		
		char	part_number[UF_UGMGR_PARTNO_SIZE+1];
		char	part_revision[UF_UGMGR_PARTREV_SIZE+1];
		char	part_file_type[UF_UGMGR_FTYPE_SIZE+1];
		char	part_file_name[UF_UGMGR_FNAME_SIZE+1];

		
		char	refset_name[ 30 + 1 ] ;
		char	instance_name[ ( 128 + 1 ) ] ;
		double	origin[3];
		double	csys_matrix[9];
		double	transform[4][4];

		tag_t	member=NULL_TAG;

		int		type=UF_ATTR_string;
		char*	title="RIVET";
		int		title_type;
		
		tag_t	member_array[100];
		int		member_count;
		
		char*	path_name;
		char	part_name[ 256 + 1 ];
		


		for(i=0;i<path_count;i++)
		{

			
			// Returns data about an instance or a part occurrence
			errorCode=UF_ASSEM_ask_component_data
			(path_array[i],part_name,refset_name,instance_name,
			origin,csys_matrix,transform);PRTERR;

			

			// Decodes the specified NX Manager part file name into its constituent
			// elements - the part number, part revision, part file type, and part file
			// name. 

			errorCode=UF_UGMGR_decode_part_filename
			(part_name,part_number,part_revision,part_file_type,part_file_name);PRTERR;



			//     9  
			path_name=part_number;
			path_name[9]='\0';

			//  -    - ?
			

			member_count=0;
			member=NULL_TAG;
			errorCode=UF_ASSEM_cycle_objs_in_comp(path_array[i],&member);PRTERR;

			if(member)
			{
			
				errorCode=UF_ATTR_find_attribute(member,type,title,&title_type);PRTERR;
				if(title_type==UF_ATTR_string)
				{
					member_array[member_count]=member;
					member_count++;
				}
			}


			while(member)
			{
				errorCode=UF_ASSEM_cycle_objs_in_comp(path_array[i],&member);PRTERR;
				if(member)
				{
					errorCode=UF_ATTR_find_attribute(member,type,title,&title_type);PRTERR;
					if(title_type==UF_ATTR_string)
					{
						member_array[member_count]=member;
						member_count++;
					}//end <<if>>
				}//end <<if>>
			}//end <<while>>


			if(member_count>99)
			{
				uc1601("   99 ",1);
				fprintf(prterr,"\n\t  $s  99 \tline=$d\n",
				path_name,__LINE__);
				goto term;
			}
			fprintf(prterr,"\n\tpath_name= %s\t   member_count= %d\n",
			path_name,member_count);
			
			//**********************************************************
			//  $$PATH
			//**********************************************************
			fprintf(fpdf,"$$PATH,\t%s,\t%d\n",path_name,member_count);


			//***********************************************************
			//
			//    Position and Action Line
			//
			//***********************************************************
			errorCode=Position_and_Action_Line(path_name,member_array,member_count);
			if(errorCode)
				uc1601(" FPDF ()  ,   prterr.txt",1);

		}//end <<for>>


	}//end <<program block>>
	

	goto term;
term:
	return errorCode;

}










/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm*	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;

	
	time(&start_time);	// 

	//     D:
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
		goto label_clock;

	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n <create_FPDF>	HAS STARTED		line=%d\n",__LINE__);
	
	fprintf(prterr,"\n    :	%s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR;


	

	*returnCode=do_it();


	if(errorCode==0)
		uc1601(" FPDF ()  ",1);
	

	errorCode=UF_terminate();PRTERR;

	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <create_FPDF>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);

	//23  2007  <<==============
	if(prterr!=NULL)
	{
		fflush(prterr);
		fclose(prterr);
	}
		
	if(fpdf!=NULL)
	{
		fflush(fpdf);
		fclose(fpdf);
	}

	
	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}

